/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XButtonBridge } from "./XButtonBridge";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { SvgIconRegistry } from "igniteui-react-core";
/**
 * @hidden
 */
export let XIconButtonBridge = /*@__PURE__*/ (() => {
    class XIconButtonBridge extends XButtonBridge {
        constructor(a, b) {
            super(a);
            this.i = null;
            this.j = "default";
            this.k = null;
            this.i = b;
        }
        getValue(a, b) {
            let c = a;
            switch (b) {
                case 14: return this.k;
                case 13: return this.j;
                case 16: return enumGetBox(BaseControlTheme_$type, c.i);
            }
            return super.getValue(a, b);
        }
        setValue(a, b, c) {
            let d = a;
            switch (b) {
                case 13:
                    {
                        this.j = c;
                        let e = a;
                        e.svgPath = SvgIconRegistry.instance.getSvgPathString(this.j, this.k);
                    }
                    return;
                case 14:
                    {
                        this.k = c;
                        let f = a;
                        f.svgPath = SvgIconRegistry.instance.getSvgPathString(this.j, this.k);
                    }
                    return;
                case 16:
                    d.i = EnumUtil.getEnumValue(BaseControlTheme_$type, c);
                    break;
            }
            super.setValue(a, b, c);
        }
        getTargetForBuildInProperty(a, b) {
            switch (b) {
                case 13:
                case 14: return this.i;
            }
            return super.getTargetForBuildInProperty(a, b);
        }
    }
    XIconButtonBridge.$t = /*@__PURE__*/ markType(XIconButtonBridge, 'XIconButtonBridge', XButtonBridge.$);
    return XIconButtonBridge;
})();
