/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-react-core";
import { INativeUIElementFactory_$type } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { XInputGroup } from "./XInputGroup";
import { XInput } from "./XInput";
import { XInputBridge } from "./XInputBridge";
import { NativeUIInput } from "igniteui-react-core";
import { XButton } from "./XButton";
import { XButtonBridge } from "./XButtonBridge";
import { NativeUIButton } from "igniteui-react-core";
import { XCheckbox } from "./XCheckbox";
import { XCheckboxBridge } from "./XCheckboxBridge";
import { NativeUICheckbox } from "igniteui-react-core";
import { XIcon } from "./XIcon";
import { XIconButtonBridge } from "./XIconButtonBridge";
import { NativeUIIconButton } from "igniteui-react-core";
/**
 * @hidden
 */
var NativeUIXInputsFactory = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NativeUIXInputsFactory, _super);
    function NativeUIXInputsFactory() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 2;
        return _this;
    }
    Object.defineProperty(NativeUIXInputsFactory, "b", {
        get: function () {
            if (NativeUIXInputsFactory.a == null) {
                NativeUIXInputsFactory.a = new NativeUIXInputsFactory();
            }
            return NativeUIXInputsFactory.a;
        },
        enumerable: false,
        configurable: true
    });
    NativeUIXInputsFactory.h = function () {
        NativeUIComponent.ab(NativeUIXInputsFactory.b);
    };
    Object.defineProperty(NativeUIXInputsFactory.prototype, "flavor", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    NativeUIXInputsFactory.prototype.createComponent = function (a, b, c) {
        switch (b) {
            case 1:
                this.d(a, c);
                break;
            case 6:
                this.e(a, c);
                break;
            case 10:
                this.f(a, c);
                break;
            case 2:
                this.g(a, c);
                break;
        }
    };
    NativeUIXInputsFactory.prototype.createComponentSync = function (a, b, c) {
        this.createComponent(a, b, c);
    };
    NativeUIXInputsFactory.prototype.supportsComponent = function (a) {
        switch (a) {
            case 1: return true;
            case 6: return true;
            case 10: return true;
            case 2: return true;
        }
        return false;
    };
    NativeUIXInputsFactory.prototype.g = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XInputGroup();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, null);
        var h = c.createElement("div");
        h.setRawStyleProperty("width", "100%");
        var i = c.getSubRenderer(h);
        var j = new XInput();
        j.provideContainer(i);
        var k = e.getExternal(j, i.rootWrapper, null);
        f.appendContentChild(h);
        f.inputs.add(j);
        var l = new XInputBridge(f);
        var m = new NativeUIInput();
        m.x = d;
        m.d = l;
        b(m);
    };
    NativeUIXInputsFactory.prototype.d = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XButton();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XButtonBridge(f);
        var i = new NativeUIButton();
        i.x = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.e = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XCheckbox();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XCheckboxBridge(f);
        var i = new NativeUICheckbox();
        i.x = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.f = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XButton();
        f.provideContainer(e);
        f.e = 4;
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = c.createElement("div");
        var i = c.getSubRenderer(h);
        var j = new XIcon();
        j.provideContainer(i);
        var k = e.getExternal(j, i.rootWrapper, i.getExternal(j, null, null));
        f.appendButtonContent(h);
        var l = new XIconButtonBridge(f, j);
        var m = new NativeUIIconButton();
        m.x = d;
        m.d = l;
        b(m);
    };
    NativeUIXInputsFactory.$t = markType(NativeUIXInputsFactory, 'NativeUIXInputsFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUIXInputsFactory.a = null;
    return NativeUIXInputsFactory;
}(Base));
export { NativeUIXInputsFactory };
