import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { IIcon } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
/**
 * @hidden
 */
export declare class IconView extends Base {
    static $t: Type;
    constructor();
    b: XIcon;
    u(): void;
    e(): boolean;
    h: DomRenderer;
    private c;
    private g;
    get k(): any;
    get l(): any;
    get f(): boolean;
    s(a: DomRenderer): void;
    private m;
    x(a: string): void;
    w(): void;
    private n;
    v(): void;
    private o;
    private p;
    private d;
    private i;
    private j;
    q(): void;
    t(): void;
    y(a: FontInfo): void;
    a(): number[];
    private r;
}
/**
 * @hidden
 */
export declare class XIcon extends Base implements INotifyPropertyChanged, IIcon {
    static $t: Type;
    constructor();
    private _view;
    get view(): IconView;
    set view(a: IconView);
    destroy(): void;
    protected bf(a: string, b: any, c: any): void;
    protected bh(a: string, b: any, c: any): void;
    private bl;
    protected get l(): boolean;
    private bk;
    private bj;
    static b2: Brush;
    static b6: Brush;
    static b5: Brush;
    static b3: Brush;
    static b4: Brush;
    static x: number;
    static w: number;
    private d;
    get e(): BaseControlTheme;
    set e(a: BaseControlTheme);
    private bm;
    get bx(): Brush;
    set bx(a: Brush);
    private bq;
    get b1(): Brush;
    set b1(a: Brush);
    private bn;
    get by(): Brush;
    set by(a: Brush);
    private bo;
    get bz(): Brush;
    set bz(a: Brush);
    private bp;
    get b0(): Brush;
    set b0(a: Brush);
    private p;
    get u(): number;
    set u(a: number);
    private q;
    get v(): number;
    set v(a: number);
    private br;
    get fill(): Brush;
    set fill(a: Brush);
    private bw;
    get cb(): Brush;
    set cb(a: Brush);
    private ah;
    get svgPath(): string;
    set svgPath(a: string);
    private bs;
    get b7(): Brush;
    set b7(a: Brush);
    private bt;
    get b8(): Brush;
    set b8(a: Brush);
    private bv;
    get ca(): Brush;
    set ca(a: Brush);
    private r;
    get y(): number;
    set y(a: number);
    private t;
    get aa(): number;
    set aa(a: number);
    bd(): void;
    be(): void;
    private f;
    get g(): FontInfo;
    set g(a: FontInfo);
    private bu;
    get b9(): Brush;
    set b9(a: Brush);
    private static ad;
    private ag;
    get ay(): string;
    set ay(a: string);
    private ab;
    private h;
    get k(): boolean;
    get ac(): number;
    set ac(a: number);
    private af;
    get ap(): string;
    set ap(a: string);
    private j;
    get n(): boolean;
    set n(a: boolean);
    private i;
    get disabled(): boolean;
    set disabled(a: boolean);
    private s;
    get z(): number;
    set z(a: number);
    bg(): void;
    clicked: (sender: any, args: IconClickedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    bb(): void;
    protected o(): boolean;
    ae(): any;
    as(): string;
    a(): IconVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
