/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { IIcon_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let IconView = /*@__PURE__*/ (() => {
    class IconView extends Base {
        constructor() {
            super();
            this.b = null;
            this.h = null;
            this.c = null;
            this.g = new List$1(Delegate_$type, 0);
            this.m = null;
            this.d = true;
            this.i = null;
            this.j = null;
        }
        u() {
        }
        e() {
            return true;
        }
        get k() {
            return this.i;
        }
        get l() {
            return null;
        }
        get f() {
            return true;
        }
        s(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.g.clear();
                if (this.i != null) {
                    this.i.unlistenAll();
                }
            }
            this.h = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            this.h.rootWrapper.setStyleProperty("display", "flex");
            this.h.rootWrapper.setStyleProperty("flex-direction", "row");
            this.h.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.h.rootWrapper.setStyleProperty("align-items", "center");
            this.w();
            let c = this.h.createElementNS("svg", "http://www.w3.org/2000/svg");
            c.setStyleProperty("position", "absolute");
            c.setStyleProperty("top", "0");
            c.setStyleProperty("left", "0");
            c.setStyleProperty("right", "0");
            c.setStyleProperty("bottom", "0");
            c.setAttribute("viewBox", "0 0 24 24");
            this.i = c;
            let d = this.h.createElementNS("path", "http://www.w3.org/2000/svg");
            d.setAttribute("d", "");
            this.i.append(d);
            if (this.m != null) {
                d.setAttribute("d", this.m);
            }
            this.j = d;
            this.h.append(this.i);
            this.g.add(c.listen("click", runOn(this, this.r)));
            this.b.bg();
        }
        x(a) {
            if (this.m != a) {
                this.m = a;
                if (this.j != null) {
                    this.j.setAttribute("d", this.m);
                }
            }
        }
        w() {
            this.h.rootWrapper.setStyleProperty("width", "1.5rem");
            this.h.rootWrapper.setStyleProperty("height", "1.5rem");
        }
        n(a) {
        }
        v() {
            if (this.e()) {
            }
        }
        o(a) {
            this.b.bd();
        }
        p(a) {
            this.b.be();
        }
        q() {
            this.d = true;
            this.g.add(this.h.rootWrapper.listen("mouseenter", runOn(this, this.o)));
            this.g.add(this.h.rootWrapper.listen("mouseleave", runOn(this, this.p)));
        }
        t() {
            this.d = false;
            for (let a of fromEnum(this.g)) {
                a();
            }
            this.g.clear();
        }
        y(a) {
            if (a != null) {
                this.h.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        a() {
            let rect_ = this.h.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
        r(a) {
            this.b.bb();
        }
    }
    IconView.$t = /*@__PURE__*/ markType(IconView, 'IconView');
    return IconView;
})();
/**
 * @hidden
 */
export let XIcon = /*@__PURE__*/ (() => {
    class XIcon extends Base {
        constructor() {
            super();
            this._view = null;
            this.d = 0;
            this.bm = XIcon.b2;
            this.bq = XIcon.b6;
            this.bn = XIcon.b3;
            this.bo = XIcon.b4;
            this.bp = XIcon.b5;
            this.p = XIcon.w;
            this.q = XIcon.x;
            this.br = XIcon.b2;
            this.bw = XIcon.b6;
            this.ah = null;
            this.bs = XIcon.b3;
            this.bt = XIcon.b4;
            this.bv = XIcon.b5;
            this.r = XIcon.w;
            this.t = XIcon.x;
            this.f = null;
            this.bu = null;
            this.ag = "ig-icon-" + XIcon.ad++;
            this.ab = 0;
            this.h = false;
            this.af = null;
            this.j = false;
            this.i = false;
            this.s = 1;
            this.clicked = null;
            this.propertyChanged = null;
            let a = new IconView();
            a.b = this;
            this.view = a;
            this.view.u();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        bf(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.bh(a, b, c);
        }
        bh(a, b, c) {
            switch (a) {
                case "Fill":
                case "Stroke":
                case "StrokeThickness":
                case "HoverFill":
                case "HoverStroke":
                case "HoverStrokeThickness":
                    this.bl();
                    break;
                case "ActualFill":
                case "ActualStroke":
                case "ActualHoverFill":
                case "ActualHoverStroke":
                case "ActualStrokeThickness":
                case "ActualHoverStrokeThickness":
                case "SVGPath":
                    this.bj();
                    break;
                case "Opacity":
                    this.bk();
                    break;
            }
        }
        bl() {
            this.bx = this.fill != null ? this.fill : XIcon.b2;
            this.by = this.b7 != null ? this.b7 : XIcon.b3;
            this.b0 = this.ca != null ? this.ca : XIcon.b5;
            this.bz = this.b8 != null ? this.b8 : XIcon.b4;
            this.v = !isNaN_(this.aa) ? this.aa : XIcon.x;
            this.u = !isNaN_(this.y) ? this.y : XIcon.w;
            this.b1 = this.cb != null ? this.cb : XIcon.b6;
        }
        get l() {
            return this.svgPath != null && !this.view.f;
        }
        bk() {
            NativeUI.u(this.view.k, this.z);
        }
        bj() {
            let a = this.view.k;
            if (this.l) {
                let b = this.view.l;
                if (this.n) {
                    NativeUI.p(b, this.by);
                    NativeUI.w(b, this.bz);
                    NativeUI.z(b, this.u);
                }
                else {
                    NativeUI.p(b, this.bx);
                    NativeUI.w(b, this.b0);
                    NativeUI.z(b, this.v);
                }
            }
            else {
                if (this.svgPath != null) {
                    this.view.x(this.svgPath);
                }
                let c = this.view.k;
                if (this.n) {
                    if (this.by != null) {
                        NativeUI.p(c, this.by);
                    }
                    if (this.bz != null) {
                        NativeUI.w(c, this.bz);
                    }
                    if (!isNaN_(this.u)) {
                        NativeUI.z(c, this.u);
                    }
                }
                else {
                    if (this.bx != null) {
                        NativeUI.p(c, this.bx);
                    }
                    if (this.b0 != null) {
                        NativeUI.w(c, this.b0);
                    }
                    if (!isNaN_(this.v)) {
                        NativeUI.z(c, this.v);
                    }
                }
            }
            if (this.g != null) {
                this.view.y(this.g);
            }
            if (this.b1 != null) {
                NativeUI.o(this.view.k, this.b1);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.bf("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get bx() {
            return this.bm;
        }
        set bx(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.bf("ActualFill", b, a);
            }
        }
        get b1() {
            return this.bq;
        }
        set b1(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.bf("ActualTextColor", b, a);
            }
        }
        get by() {
            return this.bn;
        }
        set by(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.bf("ActualHoverFill", b, a);
            }
        }
        get bz() {
            return this.bo;
        }
        set bz(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.bf("ActualHoverStroke", b, a);
            }
        }
        get b0() {
            return this.bp;
        }
        set b0(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.bf("ActualStroke", b, a);
            }
        }
        get u() {
            return this.p;
        }
        set u(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.bf("ActualHoverStrokeThickness", b, a);
            }
        }
        get v() {
            return this.q;
        }
        set v(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.bf("ActualStrokeThickness", b, a);
            }
        }
        get fill() {
            return this.br;
        }
        set fill(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.bf("Fill", b, a);
            }
        }
        get cb() {
            return this.bw;
        }
        set cb(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.bf("TextColor", b, a);
            }
        }
        get svgPath() {
            return this.ah;
        }
        set svgPath(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.bf("SVGPath", b, a);
            }
        }
        get b7() {
            return this.bs;
        }
        set b7(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.bf("HoverFill", b, a);
            }
        }
        get b8() {
            return this.bt;
        }
        set b8(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.bf("HoverStroke", b, a);
            }
        }
        get ca() {
            return this.bv;
        }
        set ca(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.bf("Stroke", b, a);
            }
        }
        get y() {
            return this.r;
        }
        set y(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.bf("HoverStrokeThickness", b, a);
            }
        }
        get aa() {
            return this.t;
        }
        set aa(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.bf("StrokeThickness", b, a);
            }
        }
        bd() {
            this.n = true;
        }
        be() {
            this.n = false;
        }
        get g() {
            return this.f;
        }
        set g(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.bf("TextStyle", b, a);
            }
        }
        get b9() {
            return this.bu;
        }
        set b9(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.bf("HoverTextColor", b, a);
            }
        }
        get ay() {
            return this.ag;
        }
        set ay(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.bf("Id", b, a);
            }
        }
        get k() {
            return this.h;
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            let b = this.ab;
            this.ab = a;
            this.h = true;
            if (b != this.ab) {
                this.bf("TabIndex", b, a);
            }
        }
        get ap() {
            return this.af;
        }
        set ap(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.bf("AriaLabel", b, a);
            }
        }
        get n() {
            return this.j;
        }
        set n(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.bf("IsHover", b, a);
            }
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.bf("IsDisabled", b, a);
            }
        }
        get z() {
            return this.s;
        }
        set z(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.bf("Opacity", b, this.s);
            }
        }
        bg() {
        }
        onDetachedFromUI() {
            this.view.t();
        }
        onAttachedToUI() {
            this.view.q();
        }
        bb() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new IconClickedEventArgs());
            }
        }
        o() {
            return this.view.e();
        }
        ae() {
            return this.a();
        }
        as() {
            let a = this.a();
            return a.j();
        }
        a() {
            let a = new IconVisualModelExport();
            let b = this.view.k;
            a.a = AppearanceHelper.a(NativeUI.ah(b));
            a.c = AppearanceHelper.a(NativeUI.ah(b));
            a.b = AppearanceHelper.a(NativeUI.ai(b));
            a.d = this.v;
            let c = this.view.a();
            a.h = c[0];
            a.f = c[1];
            a.e = NativeUI.c(b);
            a.i = NativeUI.i(b);
            a.svgPath = this.svgPath;
            if (this.g != null) {
                let d = this.g;
                if (this.view != null && d.n == null) {
                    let e = this.view.h;
                    let f = FontUtil.getFontInfoFromString(e, d.fontString);
                    d.n = f.n;
                    d.d = f.d;
                    d.o = f.o;
                    d.q = f.q;
                    d.r = f.r;
                    d.s = f.s;
                }
                if (d.n != null) {
                    a.l = d.n;
                }
                if (!isNaN_(d.d)) {
                    a.g = d.d;
                }
                if (d.s != null) {
                    a.p = d.s;
                }
                if (d.q != null) {
                    a.n = d.q;
                }
                if (d.o != null) {
                    a.m = d.q;
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.s(a);
        }
    }
    XIcon.$t = /*@__PURE__*/ markType(XIcon, 'XIcon', Base.$, [INotifyPropertyChanged_$type, IIcon_$type]);
    XIcon.b2 = null;
    XIcon.b6 = null;
    XIcon.b5 = null;
    XIcon.b3 = null;
    XIcon.b4 = null;
    XIcon.x = 0;
    XIcon.w = 0;
    XIcon.ad = 0;
    return XIcon;
})();
