/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { XComponentBridge } from "./XComponentBridge";
import { runOn, delegateCombine, delegateRemove, typeCast, EnumUtil, enumGetBox, markType } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { NativeUIButtonClickedEventArgs } from "igniteui-react-core";
import { NativeUIDisplayDensity_$type } from "igniteui-react-core";
/**
 * @hidden
 */
var XButtonBridge = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XButtonBridge, _super);
    function XButtonBridge(a) {
        var _this = _super.call(this, a) || this;
        _this.g = null;
        _this.e = null;
        _this.d = null;
        _this.f = null;
        return _this;
    }
    XButtonBridge.prototype.addHandler = function (a, b, c, d) {
        var e = a;
        switch (c) {
            case 1:
                e.clicked = delegateCombine(e.clicked, runOn(this, this.h));
                this.d = d;
                this.f = b;
                break;
        }
    };
    XButtonBridge.prototype.removeHandler = function (a, b, c, d) {
        var e = a;
        switch (c) {
            case 1:
                e.clicked = delegateRemove(e.clicked, runOn(this, this.h));
                this.d = null;
                this.f = null;
                break;
        }
    };
    XButtonBridge.prototype.h = function (a, b) {
        if (this.d != null) {
            var c = new NativeUIButtonClickedEventArgs();
            this.d(this.f, c);
        }
    };
    XButtonBridge.prototype.setValue = function (a, b, c) {
        var d = a;
        switch (b) {
            case 3:
                d.clearButtonContent();
                if (typeCast(NativeUIComponent.$, c) !== null) {
                    this.e = c;
                    d.appendButtonContent(this.e.x);
                }
                else {
                    var e = d.view.k.createElement("span");
                    e.setText(c == null ? null : c.toString());
                    d.appendButtonContent(e);
                }
                break;
            case 1:
                switch (EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, c)) {
                    case 0:
                        d.m = 0;
                        break;
                    case 1:
                        d.m = 1;
                        break;
                    case 2:
                        d.m = 3;
                        break;
                    case 3:
                        d.m = 2;
                        break;
                }
                break;
        }
    };
    XButtonBridge.prototype.getValue = function (a, b) {
        var c = a;
        switch (b) {
            case 3: break;
            case 1:
                switch (c.m) {
                    case 0: return enumGetBox(NativeUIDisplayDensity_$type, 0);
                    case 1: return enumGetBox(NativeUIDisplayDensity_$type, 1);
                    case 3: return enumGetBox(NativeUIDisplayDensity_$type, 2);
                    case 2: return enumGetBox(NativeUIDisplayDensity_$type, 3);
                }
                break;
        }
        return null;
    };
    XButtonBridge.$t = markType(XButtonBridge, 'XButtonBridge', XComponentBridge.$);
    return XButtonBridge;
}(XComponentBridge));
export { XButtonBridge };
