import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { ElevationMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ButtonDisplayStyle } from "./ButtonDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
/**
 * @hidden
 */
export declare class ButtonView extends Base {
    static $t: Type;
    constructor();
    b: XButton;
    ak(): void;
    g(): boolean;
    k: DomRenderer;
    private d;
    private h;
    get q(): any;
    get r(): any;
    ae(a: DomRenderer): void;
    ag(): void;
    at(): void;
    ap(a: number): void;
    ao(a: number): void;
    am(): void;
    ah(): void;
    ac(): void;
    ai(): void;
    aj(): void;
    private s;
    aq(): void;
    al(): void;
    private t;
    private u;
    private v;
    private y;
    private x;
    private f;
    private w;
    ab(): void;
    private e;
    private n;
    private j;
    private i;
    private l;
    private c;
    private m;
    private p;
    private o;
    ad(): void;
    af(): void;
    an(): void;
    ar(a: Brush, b: Brush): void;
    as(a: number, b: ElevationMode): void;
    au(a: FontInfo): void;
    z(a: any): void;
    aa(): void;
    a(): number[];
}
/**
 * @hidden
 */
export declare class XButton extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    get view(): ButtonView;
    set view(a: ButtonView);
    ez: any;
    destroy(): void;
    protected jz(a: string, b: any, c: any): void;
    protected j1(a: string, b: any, c: any): void;
    private ke;
    private j4;
    ju(): void;
    jt(): void;
    jw(): void;
    jy(): void;
    jx(): void;
    private j3;
    static rt: Brush;
    static rh: Brush;
    static p8: Brush;
    static s: ElevationMode;
    static rk: Brush;
    static rl: Brush;
    static rm: Brush;
    static du: number;
    static dx: number;
    static dw: number;
    static dv: number;
    static rj: Brush;
    static rr: Brush;
    static ks: CornerRadius;
    static ba: number;
    static ri: Brush;
    static rs: Brush;
    static rq: Brush;
    static rp: Brush;
    static rn: Brush;
    static ro: Brush;
    static qm: Brush;
    static qn: Brush;
    static qo: Brush;
    static dh: number;
    static dk: number;
    static dj: number;
    static di: number;
    static ql: Brush;
    static qt: Brush;
    static kp: CornerRadius;
    static a7: number;
    static qk: Brush;
    static qu: Brush;
    static qs: Brush;
    static qr: Brush;
    static qp: Brush;
    static qq: Brush;
    static q8: Brush;
    static q9: Brush;
    static ra: Brush;
    static dq: number;
    static dt: number;
    static ds: number;
    static dr: number;
    static q7: Brush;
    static rf: Brush;
    static kr: CornerRadius;
    static a9: number;
    static q6: Brush;
    static rg: Brush;
    static re: Brush;
    static rd: Brush;
    static rb: Brush;
    static rc: Brush;
    static qx: Brush;
    static qy: Brush;
    static qz: Brush;
    static dl: number;
    static dp: number;
    static dn: number;
    static dm: number;
    static qw: Brush;
    static q4: Brush;
    static kq: CornerRadius;
    static a8: number;
    static qv: Brush;
    static q5: Brush;
    static q3: Brush;
    static q2: Brush;
    static q0: Brush;
    static q1: Brush;
    static qb: Brush;
    static qc: Brush;
    static qd: Brush;
    static dd: number;
    static dg: number;
    static df: number;
    static de: number;
    static qa: Brush;
    static qi: Brush;
    static ko: CornerRadius;
    static a6: number;
    static p9: Brush;
    static qj: Brush;
    static qh: Brush;
    static qg: Brush;
    static qe: Brush;
    static qf: Brush;
    static pa: Brush;
    static oy: Brush;
    static np: Brush;
    static q: ElevationMode;
    static o1: Brush;
    static o2: Brush;
    static o3: Brush;
    static cx: number;
    static c0: number;
    static cz: number;
    static cy: number;
    static o0: Brush;
    static o8: Brush;
    static kk: CornerRadius;
    static a2: number;
    static oz: Brush;
    static o9: Brush;
    static o7: Brush;
    static o6: Brush;
    static o4: Brush;
    static o5: Brush;
    static n3: Brush;
    static n4: Brush;
    static n5: Brush;
    static cl: number;
    static co: number;
    static cn: number;
    static cm: number;
    static n2: Brush;
    static oa: Brush;
    static kh: CornerRadius;
    static az: number;
    static n1: Brush;
    static ob: Brush;
    static n9: Brush;
    static n8: Brush;
    static n6: Brush;
    static n7: Brush;
    static op: Brush;
    static oq: Brush;
    static or: Brush;
    static ct: number;
    static cw: number;
    static cv: number;
    static cu: number;
    static oo: Brush;
    static ow: Brush;
    static kj: CornerRadius;
    static a1: number;
    static on: Brush;
    static ox: Brush;
    static ov: Brush;
    static ou: Brush;
    static os: Brush;
    static ot: Brush;
    static oe: Brush;
    static of: Brush;
    static og: Brush;
    static cp: number;
    static cs: number;
    static cr: number;
    static cq: number;
    static od: Brush;
    static ol: Brush;
    static ki: CornerRadius;
    static a0: number;
    static oc: Brush;
    static om: Brush;
    static ok: Brush;
    static oj: Brush;
    static oh: Brush;
    static oi: Brush;
    static ns: Brush;
    static nt: Brush;
    static nu: Brush;
    static ch: number;
    static ck: number;
    static cj: number;
    static ci: number;
    static nr: Brush;
    static nz: Brush;
    static kg: CornerRadius;
    static ay: number;
    static nq: Brush;
    static n0: Brush;
    static ny: Brush;
    static nx: Brush;
    static nv: Brush;
    static nw: Brush;
    static h: BaseControlTheme;
    sh: Brush;
    r5: Brush;
    no: Brush;
    r: ElevationMode;
    r8: Brush;
    r9: Brush;
    sa: Brush;
    d2: number;
    d5: number;
    d4: number;
    d3: number;
    r7: Brush;
    sf: Brush;
    ku: CornerRadius;
    bc: number;
    r6: Brush;
    sg: Brush;
    se: Brush;
    sd: Brush;
    sb: Brush;
    sc: Brush;
    po: Brush;
    pp: Brush;
    pq: Brush;
    c5: number;
    c8: number;
    c7: number;
    c6: number;
    pn: Brush;
    pv: Brush;
    km: CornerRadius;
    a4: number;
    pm: Brush;
    pw: Brush;
    pu: Brush;
    pt: Brush;
    pr: Brush;
    ps: Brush;
    rw: Brush;
    rx: Brush;
    ry: Brush;
    dy: number;
    d1: number;
    d0: number;
    dz: number;
    rv: Brush;
    r3: Brush;
    kt: CornerRadius;
    bb: number;
    ru: Brush;
    r4: Brush;
    r2: Brush;
    r1: Brush;
    rz: Brush;
    r0: Brush;
    pz: Brush;
    p0: Brush;
    p1: Brush;
    c9: number;
    dc: number;
    db: number;
    da: number;
    py: Brush;
    p6: Brush;
    kn: CornerRadius;
    a5: number;
    px: Brush;
    p7: Brush;
    p5: Brush;
    p4: Brush;
    p2: Brush;
    p3: Brush;
    pd: Brush;
    pe: Brush;
    pf: Brush;
    c1: number;
    c4: number;
    c3: number;
    c2: number;
    pc: Brush;
    pk: Brush;
    kl: CornerRadius;
    a3: number;
    pb: Brush;
    pl: Brush;
    pj: Brush;
    pi: Brush;
    pg: Brush;
    ph: Brush;
    private j5;
    private at;
    get bh(): number;
    set bh(a: number);
    private as;
    get bg(): number;
    set bg(a: number);
    private d;
    get e(): ButtonDisplayStyle;
    set e(a: ButtonDisplayStyle);
    private k;
    get m(): ControlDisplayDensity;
    set m(a: ControlDisplayDensity);
    private g;
    get i(): BaseControlTheme;
    set i(a: BaseControlTheme);
    private j;
    get l(): ControlDisplayDensity;
    set l(a: ControlDisplayDensity);
    private k2;
    get na(): Brush;
    set na(a: Brush);
    private ld;
    get nl(): Brush;
    set nl(a: Brush);
    private la;
    get ni(): Brush;
    set ni(a: Brush);
    private k0;
    get m8(): Brush;
    set m8(a: Brush);
    private bn;
    get cg(): number;
    set cg(a: number);
    private bl;
    get ce(): number;
    set ce(a: number);
    private bm;
    get cf(): number;
    set cf(a: number);
    private lb;
    get nj(): Brush;
    set nj(a: Brush);
    private j6;
    get kd(): CornerRadius;
    set kd(a: CornerRadius);
    private k1;
    get m9(): Brush;
    set m9(a: Brush);
    private k3;
    get nb(): Brush;
    set nb(a: Brush);
    private k4;
    get nc(): Brush;
    set nc(a: Brush);
    private k5;
    get nd(): Brush;
    set nd(a: Brush);
    private bk;
    get cd(): number;
    set cd(a: number);
    private n;
    get p(): ElevationMode;
    set p(a: ElevationMode);
    private lc;
    get nk(): Brush;
    set nk(a: Brush);
    private k9;
    get nh(): Brush;
    set nh(a: Brush);
    private k6;
    get ne(): Brush;
    set ne(a: Brush);
    private k7;
    get nf(): Brush;
    set nf(a: Brush);
    private k8;
    get ng(): Brush;
    set ng(a: Brush);
    private an;
    get aw(): number;
    set aw(a: number);
    private mv;
    get tx(): Brush;
    set tx(a: Brush);
    private mx;
    get tz(): Brush;
    set tz(a: Brush);
    private my;
    get t0(): Brush;
    set t0(a: Brush);
    private mz;
    get t1(): Brush;
    set t1(a: Brush);
    private b7;
    get ep(): number;
    set ep(a: number);
    private m2;
    get t4(): Brush;
    set t4(a: Brush);
    private mw;
    get ty(): Brush;
    set ty(a: Brush);
    private ca;
    get es(): number;
    set es(a: number);
    private b9;
    get er(): number;
    set er(a: number);
    private b8;
    get eq(): number;
    set eq(a: number);
    private av;
    get bj(): number;
    set bj(a: number);
    private kc;
    get kz(): CornerRadius;
    set kz(a: CornerRadius);
    private m4;
    get t6(): Brush;
    set t6(a: Brush);
    private lt;
    get sw(): Brush;
    set sw(a: Brush);
    private lv;
    get sy(): Brush;
    set sy(a: Brush);
    private lw;
    get sz(): Brush;
    set sz(a: Brush);
    private lx;
    get s0(): Brush;
    set s0(a: Brush);
    private bt;
    get eb(): number;
    set eb(a: number);
    private l0;
    get s3(): Brush;
    set s3(a: Brush);
    private lu;
    get sx(): Brush;
    set sx(a: Brush);
    private bw;
    get ee(): number;
    set ee(a: number);
    private bv;
    get ed(): number;
    set ed(a: number);
    private bu;
    get ec(): number;
    set ec(a: number);
    private l2;
    get s5(): Brush;
    set s5(a: Brush);
    private l3;
    get s6(): Brush;
    set s6(a: Brush);
    private l1;
    get s4(): Brush;
    set s4(a: Brush);
    private ly;
    get s1(): Brush;
    set s1(a: Brush);
    private lz;
    get s2(): Brush;
    set s2(a: Brush);
    private aq;
    get be(): number;
    set be(a: number);
    private j9;
    get kw(): CornerRadius;
    set kw(a: CornerRadius);
    private le;
    get nm(): Brush;
    set nm(a: Brush);
    private lg;
    get si(): Brush;
    set si(a: Brush);
    private lh;
    get sj(): Brush;
    set sj(a: Brush);
    private li;
    get sk(): Brush;
    set sk(a: Brush);
    private bo;
    get d6(): number;
    set d6(a: number);
    private o;
    get t(): ElevationMode;
    set t(a: ElevationMode);
    private l6;
    get s9(): Brush;
    set s9(a: Brush);
    private lf;
    get nn(): Brush;
    set nn(a: Brush);
    private cb;
    get et(): number;
    set et(a: number);
    private by;
    get eg(): number;
    set eg(a: number);
    private bx;
    get ef(): number;
    set ef(a: number);
    private u;
    get v(): FontInfo;
    set v(a: FontInfo);
    private m7;
    get t9(): Brush;
    set t9(a: Brush);
    private l8;
    get ta(): Brush;
    set ta(a: Brush);
    private m6;
    get t8(): Brush;
    set t8(a: Brush);
    private m5;
    get t7(): Brush;
    set t7(a: Brush);
    private m3;
    get t5(): Brush;
    set t5(a: Brush);
    private m0;
    get t2(): Brush;
    set t2(a: Brush);
    private m1;
    get t3(): Brush;
    set t3(a: Brush);
    private l4;
    get s7(): Brush;
    set s7(a: Brush);
    private l5;
    get s8(): Brush;
    set s8(a: Brush);
    private ao;
    get ax(): number;
    set ax(a: number);
    private j7;
    get kf(): CornerRadius;
    set kf(a: CornerRadius);
    private mk;
    get tm(): Brush;
    set tm(a: Brush);
    private mm;
    get to(): Brush;
    set to(a: Brush);
    private mn;
    get tp(): Brush;
    set tp(a: Brush);
    private mo;
    get tq(): Brush;
    set tq(a: Brush);
    private b3;
    get el(): number;
    set el(a: number);
    private mr;
    get tt(): Brush;
    set tt(a: Brush);
    private ml;
    get tn(): Brush;
    set tn(a: Brush);
    private b6;
    get eo(): number;
    set eo(a: number);
    private b5;
    get en(): number;
    set en(a: number);
    private b4;
    get em(): number;
    set em(a: number);
    private au;
    get bi(): number;
    set bi(a: number);
    private kb;
    get ky(): CornerRadius;
    set ky(a: CornerRadius);
    private mt;
    get tv(): Brush;
    set tv(a: Brush);
    private mu;
    get tw(): Brush;
    set tw(a: Brush);
    private ms;
    get tu(): Brush;
    set tu(a: Brush);
    private mp;
    get tr(): Brush;
    set tr(a: Brush);
    private mq;
    get ts(): Brush;
    set ts(a: Brush);
    private lj;
    get sl(): Brush;
    set sl(a: Brush);
    private ll;
    get sn(): Brush;
    set sn(a: Brush);
    private lm;
    get so(): Brush;
    set so(a: Brush);
    private ln;
    get sp(): Brush;
    set sp(a: Brush);
    private bp;
    get d7(): number;
    set d7(a: number);
    private l7;
    get ss(): Brush;
    set ss(a: Brush);
    private lk;
    get sm(): Brush;
    set sm(a: Brush);
    private bs;
    get ea(): number;
    set ea(a: number);
    private br;
    get d9(): number;
    set d9(a: number);
    private bq;
    get d8(): number;
    set d8(a: number);
    private ap;
    get bd(): number;
    set bd(a: number);
    private j8;
    get kv(): CornerRadius;
    set kv(a: CornerRadius);
    private lr;
    get su(): Brush;
    set su(a: Brush);
    private ls;
    get sv(): Brush;
    set sv(a: Brush);
    private lq;
    get st(): Brush;
    set st(a: Brush);
    private lo;
    get sq(): Brush;
    set sq(a: Brush);
    private lp;
    get sr(): Brush;
    set sr(a: Brush);
    private l9;
    get tb(): Brush;
    set tb(a: Brush);
    private mb;
    get td(): Brush;
    set td(a: Brush);
    private mc;
    get te(): Brush;
    set te(a: Brush);
    private md;
    get tf(): Brush;
    set tf(a: Brush);
    private bz;
    get eh(): number;
    set eh(a: number);
    private mg;
    get ti(): Brush;
    set ti(a: Brush);
    private ma;
    get tc(): Brush;
    set tc(a: Brush);
    private b2;
    get ek(): number;
    set ek(a: number);
    private b1;
    get ej(): number;
    set ej(a: number);
    private b0;
    get ei(): number;
    set ei(a: number);
    private ar;
    get bf(): number;
    set bf(a: number);
    private ka;
    get kx(): CornerRadius;
    set kx(a: CornerRadius);
    private mi;
    get tk(): Brush;
    set tk(a: Brush);
    private mj;
    get tl(): Brush;
    set tl(a: Brush);
    private mh;
    get tj(): Brush;
    set tj(a: Brush);
    private me;
    get tg(): Brush;
    set tg(a: Brush);
    private mf;
    get th(): Brush;
    set th(a: Brush);
    private static ew;
    private e7;
    get h8(): string;
    set h8(a: string);
    private static ev;
    private e6;
    get h6(): string;
    set h6(a: string);
    private e3;
    get gc(): string;
    set gc(a: string);
    private e4;
    get hf(): string;
    set hf(a: string);
    private e5;
    get hh(): string;
    set hh(a: string);
    private e1;
    get fw(): string;
    set fw(a: string);
    private ex;
    get e0(): any;
    set e0(a: any);
    private e8;
    get ih(): string;
    set ih(a: string);
    private cc;
    private z;
    get ah(): boolean;
    get eu(): number;
    set eu(a: number);
    private e2;
    get fy(): string;
    set fy(a: string);
    private ab;
    get focused(): boolean;
    set focused(a: boolean);
    private ac;
    get ak(): boolean;
    set ak(a: boolean);
    private x;
    get af(): boolean;
    set af(a: boolean);
    private w;
    get ae(): boolean;
    set ae(a: boolean);
    private ad;
    get al(): boolean;
    set al(a: boolean);
    private aa;
    get disabled(): boolean;
    set disabled(a: boolean);
    private y;
    get ag(): boolean;
    set ag(a: boolean);
    j0(): void;
    private get a();
    private jr;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    appendButtonContent(a: any): void;
    clearButtonContent(): void;
    protected am(): boolean;
    ey(): any;
    gg(): string;
    b(): ButtonVisualModelExport;
    provideContainer(a: DomRenderer): void;
    clicked: (sender: any, args: ButtonClickEventArgs) => void;
}
